Index: sys/sparc64/include/stack.h
===================================================================
RCS file: sys/sparc64/include/stack.h
diff -N sys/sparc64/include/stack.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/sparc64/include/stack.h	17 Jan 2008 19:24:53 -0000
@@ -0,0 +1,40 @@
+/*-
+ * Copyright (c) 2001 Jake Burkholder.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/sys/sparc64/include/stack.h,v 1.1 2007/12/02 20:40:34 rwatson Exp $
+ */
+
+#ifndef _MACHINE_STACK_H_
+#define	_MACHINE_STACK_H_
+
+extern char tl_trap_begin[];
+extern char tl_trap_end[];
+extern char tl_text_begin[];
+extern char tl_text_end[];
+
+#define	INKERNEL(va) \
+	((va) >= VM_MIN_KERNEL_ADDRESS && (va) <= VM_MAX_KERNEL_ADDRESS)
+
+#endif /* !_MACHINE_STACK_H_ */
Index: sys/sparc64/sparc64/db_trace.c
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/sparc64/sparc64/db_trace.c,v
retrieving revision 1.26
diff -u -r1.26 db_trace.c
--- sys/sparc64/sparc64/db_trace.c	12 Jul 2006 21:22:44 -0000	1.26
+++ sys/sparc64/sparc64/db_trace.c	17 Jan 2008 19:25:16 -0000
@@ -41,6 +41,7 @@
 
 #include <machine/cpu.h>
 #include <machine/pcb.h>
+#include <machine/stack.h>
 #include <machine/trap.h>
 #include <machine/vmparam.h>
 
@@ -50,14 +51,6 @@
 #include <ddb/db_variables.h>
 #include <ddb/db_watch.h>
 
-extern char tl_trap_begin[];
-extern char tl_trap_end[];
-extern char tl_text_begin[];
-extern char tl_text_end[];
-
-#define	INKERNEL(va) \
-	((va) >= VM_MIN_KERNEL_ADDRESS && (va) <= VM_MAX_KERNEL_ADDRESS)
-
 static db_varfcn_t db_frame;
 
 #define	DB_OFFSET(x)	(db_expr_t *)offsetof(struct trapframe, x)
@@ -297,29 +290,3 @@
 	ctx = kdb_thr_ctx(td);
 	return (db_backtrace(td, (struct frame*)(ctx->pcb_sp + SPOFF), count));
 }
-
-void
-stack_save(struct stack *st)
-{
-	struct frame *fp;
-	db_expr_t addr;
-	vm_offset_t callpc;
-
-	stack_zero(st);
-	addr = (db_expr_t)__builtin_frame_address(1);
-	fp = (struct frame *)(addr + SPOFF);
-	while (1) {
-		callpc = fp->fr_pc;
-		if (!INKERNEL(callpc))
-			break;
-		/* Don't bother traversing trap frames. */
-		if ((callpc > (u_long)tl_trap_begin &&
-		    callpc < (u_long)tl_trap_end) ||
-		    (callpc > (u_long)tl_text_begin &&
-		    callpc < (u_long)tl_text_end))
-			break;
-		if (stack_put(st, callpc) == -1)
-			break;
-		fp = (struct frame *)(fp->fr_fp + SPOFF);
-	}
-}
Index: sys/sparc64/sparc64/stack_machdep.c
===================================================================
RCS file: sys/sparc64/sparc64/stack_machdep.c
diff -N sys/sparc64/sparc64/stack_machdep.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/sparc64/sparc64/stack_machdep.c	17 Jan 2008 19:25:27 -0000
@@ -0,0 +1,90 @@
+/*-
+ * Copyright (c) 2005 Antoine Brodin
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD: src/sys/sparc64/sparc64/stack_machdep.c,v 1.1 2007/12/02 20:40:34 rwatson Exp $");
+
+#include <sys/param.h>
+#include <sys/proc.h>
+#include <sys/stack.h>
+#include <sys/systm.h>
+
+#include <vm/vm.h>
+#include <vm/vm_page.h>
+#include <vm/vm_map.h>
+
+#include <machine/cpu.h>
+#include <machine/pcb.h>
+#include <machine/stack.h>
+#include <machine/trap.h>
+#include <machine/vmparam.h>
+
+static void
+stack_capture(struct stack *st, uint64_t addr)
+{
+	struct frame *fp;
+	vm_offset_t callpc;
+
+	stack_zero(st);
+	fp = (struct frame *)(addr + SPOFF);
+	while (1) {
+		callpc = fp->fr_pc;
+		if (!INKERNEL(callpc))
+			break;
+		/* Don't bother traversing trap frames. */
+		if ((callpc > (uint64_t)tl_trap_begin &&
+		    callpc < (uint64_t)tl_trap_end) ||
+		    (callpc > (uint64_t)tl_text_begin &&
+		    callpc < (uint64_t)tl_text_end))
+			break;
+		if (stack_put(st, callpc) == -1)
+			break;
+		fp = (struct frame *)(fp->fr_fp + SPOFF);
+	}
+}
+
+void
+stack_save_td(struct stack *st, struct thread *td)
+{
+	uint64_t addr;
+
+	if (TD_IS_SWAPPED(td))
+		panic("stack_save_td: swapped");
+	if (TD_IS_RUNNING(td))
+		panic("stack_save_td: running");
+
+	addr = td->td_pcb->pcb_sp;
+	stack_capture(st, addr);
+}
+
+void
+stack_save(struct stack *st)
+{
+	uint64_t addr;
+
+	addr = (uint64_t)__builtin_frame_address(1);
+	stack_capture(st, addr);
+}
Index: sys/sun4v/conf/GENERIC
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/sun4v/conf/GENERIC,v
retrieving revision 1.14.2.1
diff -u -r1.14.2.1 GENERIC
--- sys/sun4v/conf/GENERIC	11 Oct 2007 06:20:27 -0000	1.14.2.1
+++ sys/sun4v/conf/GENERIC	17 Jan 2008 19:26:30 -0000
@@ -55,6 +55,7 @@
 options 	COMPAT_FREEBSD5		# Compatible with FreeBSD5
 options 	SCSI_DELAY=5000		# Delay (in ms) before probing SCSI
 options 	KTRACE			# ktrace(1) support
+options 	STACK			# stack(9) support
 options 	SYSVSHM			# SYSV-style shared memory
 options 	SYSVMSG			# SYSV-style message queues
 options 	SYSVSEM			# SYSV-style semaphores
Index: sys/sun4v/include/stack.h
===================================================================
RCS file: sys/sun4v/include/stack.h
diff -N sys/sun4v/include/stack.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/sun4v/include/stack.h	17 Jan 2008 19:26:43 -0000
@@ -0,0 +1,35 @@
+/*-
+ * Copyright (c) 2001 Jake Burkholder.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/sys/sun4v/include/stack.h,v 1.1 2007/12/02 20:40:35 rwatson Exp $
+ */
+
+#ifndef _MACHINE_STACK_H_
+#define	_MACHINE_STACK_H_
+
+#define	INKERNEL(va) \
+	((va) >= VM_MIN_KERNEL_ADDRESS && (va) <= VM_MAX_KERNEL_ADDRESS)
+
+#endif /* !_MACHINE_STACK_H_ */
Index: sys/sun4v/sun4v/db_trace.c
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/sun4v/sun4v/db_trace.c,v
retrieving revision 1.1
diff -u -r1.1 db_trace.c
--- sys/sun4v/sun4v/db_trace.c	5 Oct 2006 06:14:28 -0000	1.1
+++ sys/sun4v/sun4v/db_trace.c	17 Jan 2008 19:27:33 -0000
@@ -40,6 +40,7 @@
 
 #include <machine/cpu.h>
 #include <machine/pcb.h>
+#include <machine/stack.h>
 #include <machine/trap.h>
 #include <machine/vmparam.h>
 
@@ -49,9 +50,6 @@
 #include <ddb/db_variables.h>
 #include <ddb/db_watch.h>
 
-#define	INKERNEL(va) \
-	((va) >= VM_MIN_KERNEL_ADDRESS && (va) <= VM_MAX_KERNEL_ADDRESS)
-
 static db_varfcn_t db_frame;
 
 #define	DB_OFFSET(x)	(db_expr_t *)offsetof(struct trapframe, x)
@@ -304,23 +302,3 @@
 	ctx = kdb_thr_ctx(td);
 	return (db_backtrace(td, (struct frame*)(ctx->pcb_sp + SPOFF), count));
 }
-
-void
-stack_save(struct stack *st)
-{
-	struct frame *fp;
-	db_expr_t addr;
-	vm_offset_t callpc;
-
-	stack_zero(st);
-	addr = (db_expr_t)__builtin_frame_address(1);
-	fp = (struct frame *)(addr + SPOFF);
-	while (1) {
-		callpc = fp->fr_pc;
-		if (!INKERNEL(callpc))
-			break;
-		if (stack_put(st, callpc) == -1)
-			break;
-		fp = (struct frame *)(fp->fr_fp + SPOFF);
-	}
-}
Index: sys/sun4v/sun4v/stack_machdep.c
===================================================================
RCS file: sys/sun4v/sun4v/stack_machdep.c
diff -N sys/sun4v/sun4v/stack_machdep.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/sun4v/sun4v/stack_machdep.c	17 Jan 2008 19:27:46 -0000
@@ -0,0 +1,85 @@
+/*-
+ * Copyright (c) 2005 Antoine Brodin
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD: src/sys/sun4v/sun4v/stack_machdep.c,v 1.1 2007/12/02 20:40:35 rwatson Exp $");
+
+#include <sys/param.h>
+#include <sys/proc.h>
+#include <sys/stack.h>
+#include <sys/systm.h>
+
+#include <vm/vm.h>
+#include <vm/vm_page.h>
+#include <vm/vm_map.h>
+
+#include <machine/cpu.h>
+#include <machine/pcb.h>
+#include <machine/stack.h>
+#include <machine/trap.h>
+#include <machine/vmparam.h>
+
+static void
+stack_capture(struct stack *st, uint64_t addr)
+{
+	struct frame *fp;
+	vm_offset_t callpc;
+
+	stack_zero(st);
+	fp = (struct frame *)(addr + SPOFF);
+	while (1) {
+		callpc = fp->fr_pc;
+		if (!INKERNEL(callpc))
+			break;
+		if (stack_put(st, callpc) == -1)
+			break;
+		fp = (struct frame *)(fp->fr_fp + SPOFF);
+	}
+
+}
+
+void
+stack_save_td(struct stack *st, struct thread *td)
+{
+	uint64_t addr;
+
+	if (TD_IS_SWAPPED(td))
+		panic("stack_save_td: swapped");
+	if (TD_IS_RUNNING(td))
+		panic("stack_save_td: running");
+
+	addr = td->td_pcb->pcb_sp;
+	stack_capture(st, addr);
+}
+
+void
+stack_save(struct stack *st)
+{
+	uint64_t addr;
+
+	addr = (uint64_t)__builtin_frame_address(1);
+	stack_capture(st, addr);
+}
Index: sys/sys/linker.h
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/sys/linker.h,v
retrieving revision 1.46
diff -u -r1.46 linker.h
--- sys/sys/linker.h	20 Jun 2006 20:59:55 -0000	1.46
+++ sys/sys/linker.h	17 Jan 2008 17:01:41 -0000
@@ -155,6 +155,14 @@
 int linker_ddb_search_symbol(caddr_t _value, c_linker_sym_t *_sym,
 			     long *_diffp);
 int linker_ddb_symbol_values(c_linker_sym_t _sym, linker_symval_t *_symval);
+int linker_ddb_search_symbol_name(caddr_t value, char *buf, u_int buflen,
+				  long *offset);
+
+/*
+ * stack(9) helper for situations where kernel locking is required.
+ */
+int linker_search_symbol_name(caddr_t value, char *buf, u_int buflen,
+    long *offset);
 
 
 /* HWPMC helper */
Index: sys/sys/stack.h
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/sys/stack.h,v
retrieving revision 1.2
diff -u -r1.2 stack.h
--- sys/sys/stack.h	29 Aug 2005 11:34:08 -0000	1.2
+++ sys/sys/stack.h	17 Jan 2008 19:27:58 -0000
@@ -45,7 +45,9 @@
 void		 stack_copy(struct stack *, struct stack *);
 void		 stack_zero(struct stack *);
 void		 stack_print(struct stack *);
+void		 stack_print_ddb(struct stack *);
 void		 stack_sbuf_print(struct sbuf *, struct stack *);
+void		 stack_sbuf_print_ddb(struct sbuf *, struct stack *);
 #ifdef KTR
 void		 stack_ktr(u_int, const char *, int, struct stack *, u_int, int);
 #define	CTRSTACK(m, st, depth, cheap) do {				\
@@ -57,6 +59,8 @@
 #endif
 
 /* MD Routine. */
+struct thread;
 void		 stack_save(struct stack *);
+void		 stack_save_td(struct stack *, struct thread *);
 
 #endif
Index: sys/sys/sysctl.h
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/sys/sysctl.h,v
retrieving revision 1.148
diff -u -r1.148 sysctl.h
--- sys/sys/sysctl.h	4 Jun 2007 18:14:28 -0000	1.148
+++ sys/sys/sysctl.h	17 Jan 2008 19:28:45 -0000
@@ -456,6 +456,9 @@
 #define	KERN_PROC_RGID		10	/* by real group id */
 #define	KERN_PROC_GID		11	/* by effective group id */
 #define	KERN_PROC_PATHNAME	12	/* path to executable */
+#define	KERN_PROC_VMMAP		13	/* VM map entries for process */
+#define	KERN_PROC_FILEDESC	14	/* File descriptors for process */
+#define	KERN_PROC_KSTACK	15	/* Kernel stacks for process */
 #define	KERN_PROC_INC_THREAD	0x10	/*
 					 * modifier for pid, pgrp, tty,
 					 * uid, ruid, gid, rgid and proc
@@ -618,6 +621,7 @@
 extern struct sysctl_oid_list sysctl__children;
 SYSCTL_DECL(_kern);
 SYSCTL_DECL(_kern_ipc);
+SYSCTL_DECL(_kern_proc);
 SYSCTL_DECL(_sysctl);
 SYSCTL_DECL(_vm);
 SYSCTL_DECL(_vm_stats);
Index: sys/sys/user.h
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/sys/user.h,v
retrieving revision 1.70
diff -u -r1.70 user.h
--- sys/sys/user.h	17 Sep 2007 05:27:21 -0000	1.70
+++ sys/sys/user.h	17 Jan 2008 16:53:30 -0000
@@ -1,6 +1,8 @@
 /*-
  * Copyright (c) 1982, 1986, 1989, 1991, 1993
- *	The Regents of the University of California.  All rights reserved.
+ *	The Regents of the University of California.
+ * Copyright (c) 2007 Robert N. M. Watson
+ * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -56,6 +58,9 @@
 #ifndef _SYS_SIGNALVAR_H_
 #include <sys/signalvar.h>
 #endif
+#ifndef _SYS_SOCKET_VAR_H_
+#include <sys/socket.h>
+#endif
 
 /*
  * KERN_PROC subtype ops return arrays of selected proc structure entries:
@@ -228,4 +233,109 @@
 	struct	kinfo_proc u_kproc;	/* eproc */
 };
 
+/*
+ * The KERN_PROC_FILE sysctl allows a process to dumpt the file descriptor
+ * array of another process.
+ */
+#define	KF_TYPE_NONE	0
+#define	KF_TYPE_VNODE	1
+#define	KF_TYPE_SOCKET	2
+#define	KF_TYPE_PIPE	3
+#define	KF_TYPE_FIFO	4
+#define	KF_TYPE_KQUEUE	5
+#define	KF_TYPE_CRYPTO	6
+#define	KF_TYPE_MQUEUE	7
+#define	KF_TYPE_UNKNOWN	255
+
+#define	KF_VTYPE_VNON	0
+#define	KF_VTYPE_VREG	1
+#define	KF_VTYPE_VDIR	2
+#define	KF_VTYPE_VBLK	3
+#define	KF_VTYPE_VCHR	4
+#define	KF_VTYPE_VLNK	5
+#define	KF_VTYPE_VSOCK	6
+#define	KF_VTYPE_VFIFO	7
+#define	KF_VTYPE_VBAD	8
+#define	KF_VTYPE_UNKNOWN	255
+
+#define	KF_FLAG_READ		0x00000001
+#define	KF_FLAG_WRITE		0x00000002
+#define	KF_FLAG_APPEND		0x00000004
+#define	KF_FLAG_ASYNC		0x00000008
+#define	KF_FLAG_FSYNC		0x00000010
+#define	KF_FLAG_NONBLOCK	0x00000020
+#define	KF_FLAG_DIRECT		0x00000040
+#define	KF_FLAG_HASLOCK		0x00000080
+
+struct kinfo_file {
+	int	kf_structsize;			/* Size of kinfo_file. */
+	int	kf_type;			/* Descriptor type. */
+	int	kf_fd;				/* Array index. */
+	int	kf_ref_count;			/* Reference count. */
+	int	kf_flags;			/* Flags. */
+	off_t	kf_offset;			/* Seek location. */
+	int	kf_vnode_type;			/* Vnode type. */
+	int	kf_sock_domain;			/* Socket domain. */
+	int	kf_sock_type;			/* Socket type. */
+	int	kf_sock_protocol;		/* Socket protocol. */
+	char	kf_path[PATH_MAX];		/* Path to file, if any. */
+	struct sockaddr_storage kf_sa_local;	/* Socket address. */
+	struct sockaddr_storage	kf_sa_peer;	/* Peer address. */
+};
+
+/*
+ * The KERN_PROC_VMMAP sysctl allows a process to dump the VM layout of
+ * another process as a series of entries.
+ */
+#define	KVME_TYPE_NONE		0
+#define	KVME_TYPE_DEFAULT	1
+#define	KVME_TYPE_VNODE		2
+#define	KVME_TYPE_SWAP		3
+#define	KVME_TYPE_DEVICE	4
+#define	KVME_TYPE_PHYS		5
+#define	KVME_TYPE_DEAD		6
+#define	KVME_TYPE_UNKNOWN	255
+
+#define	KVME_PROT_READ		0x00000001
+#define	KVME_PROT_WRITE		0x00000002
+#define	KVME_PROT_EXEC		0x00000004
+
+#define	KVME_FLAG_COW		0x00000001
+#define	KVME_FLAG_NEEDS_COPY	0x00000002
+
+struct kinfo_vmentry {
+	int	 kve_structsize;		/* Size of kinfo_vmmapentry. */
+	int	 kve_type;			/* Type of map entry. */
+	void	*kve_start;			/* Starting pointer. */
+	void	*kve_end;			/* Finishing pointer. */
+	int	 kve_flags;			/* Flags on map entry. */
+	int	 kve_resident;			/* Number of resident pages. */
+	int	 kve_private_resident;		/* Number of private pages. */
+	int	 kve_protection;		/* Protection bitmask. */
+	int	 kve_ref_count;			/* VM obj ref count. */
+	int	 kve_shadow_count;		/* VM obj shadow count. */
+	char	 kve_path[PATH_MAX];		/* Path to VM obj, if any. */
+	void	*_kve_pspare[8];		/* Space for more stuff. */
+	int	 _kve_ispare[8];		/* Space for more stuff. */
+};
+
+/*
+ * The KERN_PROC_KSTACK sysctl allows a process to dump the kernel stacks of
+ * another process as a series of entries.  Each stack is represented by a
+ * series of symbol names and offsets as generated by stack_sbuf_print(9).
+ */
+#define	KKST_MAXLEN	1024
+
+#define	KKST_STATE_STACKOK	0		/* Stack is valid. */
+#define	KKST_STATE_SWAPPED	1		/* Stack swapped out. */
+#define	KKST_STATE_RUNNING	2		/* Stack ephemeral. */
+
+struct kinfo_kstack {
+	lwpid_t	 kkst_tid;			/* ID of thread. */
+	int	 kkst_state;			/* Validity of stack. */
+	char	 kkst_trace[KKST_MAXLEN];	/* String representing stack. */
+	void	*_kkst_pspare[8];		/* Space for more stuff. */
+	int	 _kkst_ispare[8];		/* Space for more stuff. */
+};
+
 #endif
Index: sys/vm/redzone.c
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/vm/redzone.c,v
retrieving revision 1.1
diff -u -r1.1 redzone.c
--- sys/vm/redzone.c	31 Jan 2006 11:09:20 -0000	1.1
+++ sys/vm/redzone.c	17 Jan 2008 17:03:21 -0000
@@ -152,10 +152,10 @@
 		    "corrupted before %p (%lu bytes allocated).\n",
 		    ncorruptions, ncorruptions == 1 ? "" : "s", naddr, nsize);
 		printf("Allocation backtrace:\n");
-		stack_print(&ast);
+		stack_print_ddb(&ast);
 		printf("Free backtrace:\n");
 		stack_save(&fst);
-		stack_print(&fst);
+		stack_print_ddb(&fst);
 		if (redzone_panic)
 			panic("Stopping here.");
 	}
@@ -171,10 +171,10 @@
 		    "after %p (%lu bytes allocated).\n", ncorruptions,
 		    ncorruptions == 1 ? "" : "s", naddr + nsize, nsize);
 		printf("Allocation backtrace:\n");
-		stack_print(&ast);
+		stack_print_ddb(&ast);
 		printf("Free backtrace:\n");
 		stack_save(&fst);
-		stack_print(&fst);
+		stack_print_ddb(&fst);
 		if (redzone_panic)
 			panic("Stopping here.");
 	}
Index: usr.bin/Makefile
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/usr.bin/Makefile,v
retrieving revision 1.303
diff -u -r1.303 Makefile
--- usr.bin/Makefile	9 Oct 2007 23:31:11 -0000	1.303
+++ usr.bin/Makefile	17 Jan 2008 19:31:01 -0000
@@ -149,6 +149,7 @@
 	pr \
 	printenv \
 	printf \
+	procstat \
 	quota \
 	renice \
 	rev \
Index: usr.bin/procstat/Makefile
===================================================================
RCS file: usr.bin/procstat/Makefile
diff -N usr.bin/procstat/Makefile
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ usr.bin/procstat/Makefile	17 Jan 2008 19:30:45 -0000
@@ -0,0 +1,15 @@
+# $FreeBSD: src/usr.bin/procstat/Makefile,v 1.1 2007/12/02 23:31:45 rwatson Exp $
+
+PROG=	procstat
+MAN=	procstat.1
+SRCS=	procstat.c		\
+	procstat_args.c		\
+	procstat_basic.c	\
+	procstat_bin.c		\
+	procstat_cred.c		\
+	procstat_files.c	\
+	procstat_kstack.c	\
+	procstat_threads.c	\
+	procstat_vm.c
+
+.include <bsd.prog.mk>
Index: usr.bin/procstat/procstat.c
===================================================================
RCS file: usr.bin/procstat/procstat.c
diff -N usr.bin/procstat/procstat.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ usr.bin/procstat/procstat.c	17 Jan 2008 19:30:45 -0000
@@ -0,0 +1,252 @@
+/*-
+ * Copyright (c) 2007 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/usr.bin/procstat/procstat.c,v 1.1 2007/12/02 23:31:45 rwatson Exp $
+ */
+
+#include <sys/types.h>
+#include <sys/sysctl.h>
+#include <sys/user.h>
+
+#include <err.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <sysexits.h>
+#include <unistd.h>
+
+#include "procstat.h"
+
+static int aflag, bflag, cflag, fflag, kflag, sflag, tflag, vflag;
+int	hflag;
+
+static void
+usage(void)
+{
+
+	fprintf(stderr, "usage: procstat [-h] [-w interval] [-b | -c | -f | "
+	    "-k | -s | -t | -v]\n");
+	fprintf(stderr, "                [-a | pid ...]\n");
+	exit(EX_USAGE);
+}
+
+static void
+procstat(pid_t pid, struct kinfo_proc *kipp)
+{
+
+	if (bflag)
+		procstat_bin(pid, kipp);
+	else if (cflag)
+		procstat_args(pid, kipp);
+	else if (fflag)
+		procstat_files(pid, kipp);
+	else if (kflag)
+		procstat_kstack(pid, kipp, kflag);
+	else if (sflag)
+		procstat_cred(pid, kipp);
+	else if (tflag)
+		procstat_threads(pid, kipp);
+	else if (vflag)
+		procstat_vm(pid, kipp);
+	else
+		procstat_basic(pid, kipp);
+}
+
+/*
+ * Sort processes first by pid and then tid.
+ */
+static int
+kinfo_proc_compare(const void *a, const void *b)
+{
+	int i;
+
+	i = ((struct kinfo_proc *)a)->ki_pid -
+	    ((struct kinfo_proc *)b)->ki_pid;
+	if (i != 0)
+		return (i);
+	i = ((struct kinfo_proc *)a)->ki_tid -
+	    ((struct kinfo_proc *)b)->ki_tid;
+	return (i);
+}
+
+void
+kinfo_proc_sort(struct kinfo_proc *kipp, int count)
+{
+
+	qsort(kipp, count, sizeof(*kipp), kinfo_proc_compare);
+}
+
+int
+main(int argc, char *argv[])
+{
+	int ch, i, interval, name[4], tmp;
+	struct kinfo_proc *kipp;
+	size_t len;
+	long l;
+	pid_t pid;
+	char *dummy;
+
+	interval = 0;
+	while ((ch = getopt(argc, argv, "abcfkhstvw:")) != -1) {
+		switch (ch) {
+		case 'a':
+			aflag++;
+			break;
+
+		case 'b':
+			bflag++;
+			break;
+
+		case 'c':
+			cflag++;
+			break;
+
+		case 'f':
+			fflag++;
+			break;
+
+		case 'k':
+			kflag++;
+			break;
+
+		case 'h':
+			hflag++;
+			break;
+
+		case 's':
+			sflag++;
+			break;
+
+		case 't':
+			tflag++;
+			break;
+
+		case 'v':
+			vflag++;
+			break;
+
+		case 'w':
+			l = strtol(optarg, &dummy, 10);
+			if (*dummy != '\0')
+				usage();
+			if (l < 1 || l > INT_MAX)
+				usage();
+			interval = l;
+			break;
+
+		case '?':
+		default:
+			usage();
+		}
+
+	}
+	argc -= optind;
+	argv += optind;
+
+	/* We require that either 0 or 1 mode flags be set. */
+	tmp = bflag + cflag + fflag + (kflag ? 1 : 0) + sflag + tflag + vflag;
+	if (!(tmp == 0 || tmp == 1))
+		usage();
+
+	/* We allow -k to be specified up to twice, but not more. */
+	if (kflag > 2)
+		usage();
+
+	/* Must specify either the -a flag or a list of pids. */
+	if (!(aflag == 1 && argc == 0) && !(aflag == 0 && argc > 0))
+		usage();
+
+	do {
+		if (aflag) {
+			name[0] = CTL_KERN;
+			name[1] = KERN_PROC;
+			name[2] = KERN_PROC_PROC;
+
+			len = 0;
+			if (sysctl(name, 3, NULL, &len, NULL, 0) < 0)
+				err(-1, "sysctl: kern.proc.all");
+
+			kipp = malloc(len);
+			if (kipp == NULL)
+				err(-1, "malloc");
+
+			if (sysctl(name, 3, kipp, &len, NULL, 0) < 0) {
+				free(kipp);
+				err(-1, "sysctl: kern.proc.all");
+			}
+			if (len % sizeof(*kipp) != 0)
+				err(-1, "kinfo_proc mismatch");
+			if (kipp->ki_structsize != sizeof(*kipp))
+				err(-1, "kinfo_proc structure mismatch");
+			kinfo_proc_sort(kipp, len / sizeof(*kipp));
+			for (i = 0; i < len / sizeof(*kipp); i++) {
+				procstat(kipp[i].ki_pid, &kipp[i]);
+
+				/* Suppress header after first process. */
+				hflag = 1;
+			}
+			free(kipp);
+		}
+		for (i = 0; i < argc; i++) {
+			l = strtol(argv[i], &dummy, 10);
+			if (*dummy != '\0')
+				usage();
+			if (l < 0)
+				usage();
+			pid = l;
+
+			name[0] = CTL_KERN;
+			name[1] = KERN_PROC;
+			name[2] = KERN_PROC_PID;
+			name[3] = pid;
+
+			len = 0;
+			if (sysctl(name, 4, NULL, &len, NULL, 0) < 0)
+				err(-1, "sysctl: kern.proc.pid: %d", pid);
+
+			kipp = malloc(len);
+			if (kipp == NULL)
+				err(-1, "malloc");
+
+			if (sysctl(name, 4, kipp, &len, NULL, 0) < 0) {
+				free(kipp);
+				err(-1, "sysctl: kern.proc.pid: %d", pid);
+			}
+			if (len != sizeof(*kipp))
+				err(-1, "kinfo_proc mismatch");
+			if (kipp->ki_structsize != sizeof(*kipp))
+				errx(-1, "kinfo_proc structure mismatch");
+			if (kipp->ki_pid != pid)
+				errx(-1, "kinfo_proc pid mismatch");
+			procstat(pid, kipp);
+			free(kipp);
+
+			/* Suppress header after first process. */
+			hflag = 1;
+		}
+		if (interval)
+			sleep(interval);
+	} while (interval);
+	exit(0);
+}
Index: usr.bin/procstat/procstat.h
===================================================================
RCS file: usr.bin/procstat/procstat.h
diff -N usr.bin/procstat/procstat.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ usr.bin/procstat/procstat.h	17 Jan 2008 19:30:46 -0000
@@ -0,0 +1,46 @@
+/*-
+ * Copyright (c) 2007 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/usr.bin/procstat/procstat.h,v 1.1 2007/12/02 23:31:45 rwatson Exp $
+ */
+
+#ifndef PROCSTAT_H
+#define	PROCSTAT_H
+
+extern int	hflag;
+
+struct kinfo_proc;
+void	kinfo_proc_sort(struct kinfo_proc *kipp, int count);
+
+void	procstat_args(pid_t pid, struct kinfo_proc *kipp);
+void	procstat_basic(pid_t pid, struct kinfo_proc *kipp);
+void	procstat_bin(pid_t pid, struct kinfo_proc *kipp);
+void	procstat_cred(pid_t pid, struct kinfo_proc *kipp);
+void	procstat_files(pid_t pid, struct kinfo_proc *kipp);
+void	procstat_kstack(pid_t pid, struct kinfo_proc *kipp, int kflag);
+void	procstat_threads(pid_t pid, struct kinfo_proc *kipp);
+void	procstat_vm(pid_t pid, struct kinfo_proc *kipp);
+
+#endif /* !PROCSTAT_H */
